"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const config_1 = require("hardhat/config");
const plugins_1 = require("hardhat/plugins");
require("./type-extensions");
const defender_relay_client_1 = require("defender-relay-client");
const defender_admin_client_1 = require("defender-admin-client");
const defender_autotask_client_1 = require("defender-autotask-client");
const RelaySigners_1 = __importDefault(require("./OpenzeppelinDefender/RelaySigners"));
const defender_sentinel_client_1 = require("defender-sentinel-client");
const defender_kvstore_client_1 = require("defender-kvstore-client");
const Utils_1 = __importDefault(require("./OpenzeppelinDefender/Utils"));
config_1.extendConfig((config, userConfig) => { });
config_1.extendEnvironment((hre) => {
    hre.OpenzeppelinDefender = plugins_1.lazyObject(() => {
        const Credential = hre.config.OpenzeppelinDefenderCredential;
        const AdminClients = new defender_admin_client_1.AdminClient(Credential);
        const RelayClients = new defender_relay_client_1.RelayClient(Credential);
        const RelaySigner = new RelaySigners_1.default();
        const AutotaskClients = new defender_autotask_client_1.AutotaskClient(Credential);
        const SentinelClients = new defender_sentinel_client_1.SentinelClient(Credential);
        const KeyValueStoreClients = new defender_kvstore_client_1.KeyValueStoreClient({ path: './secret.json' });
        const Util = new Utils_1.default();
        return {
            AdminClient: AdminClients,
            RelayClient: RelayClients,
            RelaySigner,
            AutotaskClient: AutotaskClients,
            SentinelClient: SentinelClients,
            KeyValueStoreClient: KeyValueStoreClients,
            Utils: Util,
        };
    });
});
/*task("OpenzeppelinDefender", "Prints a greeting'")
  .addOptionalParam("relay", "The greeting to print", undefined)
  .addOptionalParam("autotask", "The greeting to print", undefined)
  .setAction(async ({ relay, autotask }, hre, runSuper) => {
    if (relay) {
      console.log(await hre.run("relay", { params: relay }));
    }

    if (autotask) {
      console.log(await hre.run("autotask", { params: autotask }));
    }
  });

subtask("relay", "Prints a message")
  .addParam("params", "The message to print")
  .setAction(async ({ params }, hre) => {
    if (params === "list") {
      return hre.OpenzeppelinDefender.RelayClient.list();
    }
  });

subtask("autotask", "Prints a message")
  .addParam("params", "The message to print")
  .setAction(async ({ params }, hre) => {
    if (params === "list") {
      return hre.OpenzeppelinDefender.AutotaskClient.list();
    }
  });*/
//# sourceMappingURL=index.js.map