import "hardhat/types/config";
import "hardhat/types/runtime";
import Utils from "./OpenzeppelinDefender/Utils";
import { RelayClient } from 'defender-relay-client';
import { AdminClient } from 'defender-admin-client';
import { AutotaskClient } from "defender-autotask-client";
import { KeyValueStoreClient } from 'defender-kvstore-client';
import { SentinelClient } from 'defender-sentinel-client';
import RelaySigners from './OpenzeppelinDefender/RelaySigners';
interface OpenzeppelinDefenderCredential {
    apiKey: string;
    apiSecret: string;
}
declare module "hardhat/types/config" {
    interface HardhatUserConfig {
        OpenzeppelinDefenderCredential?: OpenzeppelinDefenderCredential;
    }
    interface HardhatConfig {
        OpenzeppelinDefenderCredential: OpenzeppelinDefenderCredential;
    }
}
declare module "hardhat/types/runtime" {
    interface HardhatRuntimeEnvironment {
        OpenzeppelinDefender: {
            AdminClient: AdminClient;
            AutotaskClient: AutotaskClient;
            RelayClient: RelayClient;
            SentinelClient: SentinelClient;
            KeyValueStoreClient: KeyValueStoreClient;
            RelaySigner: RelaySigners;
            Utils: Utils;
        };
    }
}
export {};
//# sourceMappingURL=type-extensions.d.ts.map